<?php

define("table_name","cat");

class MyCat {

  //=======================================//
  //==========> Class Variables <==========//
  //=======================================//
  private $id;		//Id of the Video
  private $cname;		//YouTube Url



//=======================================================================================//
//================================= Core Methods ========================================//
//=======================================================================================//
  

  //=======================================//
  //============> Constructor <============//
  //=======================================//
  public function __construct($id=0,$cname="")
  {
    $this->id=$id;
    $this->cname = $cname;
    
  }
  
  


  
  //=======================================//
  //======> Load a Video Via its ID <======//
  //=======================================//
  public function load($id){
    //Select the Video Information from DB
    $sql="SELECT * FROM ".table_name." WHERE id = $id LIMIT 1";
    $result=array(); $video = new MyCat();
    $req = mysql_query($sql) or die("Erreur SQL !<br>".$sql."<br>".mysql_error());
    
    //Assign those Infomation to a MyVideo Object
    while($data= mysql_fetch_assoc($req)) {
      $MyCat->id = $data[id];
      $MyCat->cname = $data[cname];
      
    }
    
    return $MyCat;    
  }


  //=======================================//
  //======> Get Video List From DB <=======//  
  //=======================================//
  public function getrecords()
  {
    //Select all videos from DB
    $sql="SELECT * FROM ".table_name."";
    $result=array();
    $req = mysql_query($sql) or die("SQL Error!<br>".$sql."<br>".mysql_error());
    while($data= mysql_fetch_assoc($req)) {
      $result[]=$data;
    }
    return $result;
  }  
  
  
  //==========================================//
  //== Display the form to add/edit a Category ==//
  //==========================================//
  public function getCatForm($videoid=0,$action="", $method="post"){
    //Load A Video if $videoid (Used to edit an existing video)
    if( (!empty($videoid)) && (is_numeric($videoid)) ){ 
      $cat = MyCat::load($videoid); 
    } else { 
      $video = new MyCat(); 
    }
    
    //The Form Markup (Video Url, + Video Title)
    $form='<form action="'.$action.'" method="'.$method.'">
      <div class="regrow">
        <label class="inside" for="cat_name">Category Name:</label>
         <input id="catname"  type="text" name="cat_name" class="text" style="width:400px" value="'.$cat->cname.'" />
		
      </div>
      
      <div class="regrow">
        <input type="hidden" name="cat_id" value="'.$cat->id.'" />
        <input type="hidden" name="todo" value="savecat" />
        <input type="submit" class="submit" value="Submit" /> 
        <input id="cancelctcform" type="button" class="submit" value="Cancel" />
      </div>
    </form>
	
	';
    return $form;
  }  
  
  
  //========================================//
  //== Insert / Update a Row in the Table ==//
  //========================================//
  public function save(){
    //Get Values From Post
    $id = htmlentities($_POST["cat_id"],ENT_QUOTES);
    $name = htmlentities($_POST["cat_name"],ENT_QUOTES);
   
    
    if(!empty($name)){
      if (!$id) {	//Creation
	  //$desc=str_replace("\"","'",$desc);
        $sql = "INSERT INTO ".table_name." (`id`,`cname`) VALUES (\"$id\",\"$name\")";
        if(mysql_query($sql)) { return mysql_insert_id(); } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
      }
      else {		//Update
        $modifs="";
		//$desc=str_replace("\"","'",$desc);
        if(!empty($name)){ $modifs.=" `cname` = \"$name\","; }

        $sql = "UPDATE ".table_name." SET ".substr($modifs,0,-1)." WHERE id = $id";
        if(mysql_query($sql)) { return $id; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
      } 
    }
  }
  
  //==========================================//
  //============ Delete a Video ==============//
  //==========================================//
  public function delete(){
	$sql = "DELETE FROM ".table_name." WHERE id = ".(int)$this->id;
	if(mysql_query($sql)) { return true; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }  
  }


//=============================================================================================================================//  
//========================================= Examples Used in the Demonstration ================================================//
//=============================================================================================================================//


  //=======================================//
  //========== Create the Table ===========//
  //=======================================//
 /* public function createVideoTable(){
    $sql='CREATE TABLE IF NOT EXISTS `'.table_name.'` (
    `video_id` int(11) NOT NULL auto_increment,
    `video_url` varchar(255) default NULL,
    `video_title` varchar(255) default NULL,
    PRIMARY KEY  (`video_id`)
    )';
    if(mysql_query($sql)) { return true; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
  }*/
  
  //==============================================//
  //==> Display the video Thumbnails on a page <==//
  //==============================================//
  public function getThumbnailsList(){
    
    $thumbdom="<ul>"; $playerdom="";
    
    //Get The videos from DB
    $catlist = MyCat::getrecords();
    
    //Loop Through Them
    if(!empty($videolist)){foreach($catlist as $cat){
      
     
      
      //Build Up your list of video
      $thumbdom.='<li>
      <a class="fancy" href="#video'.$cat[cat_id].'" title="'.$cat[cat_name].'">
        '.$cat[cat_name].'</a>
      </li>';
      
      
    }}
    $thumbdom.="</ul>";
    $dom='<div id="thumbnailscontainer">'.$thumbdom.'</div>';
    
    return $dom;
  }
  
  
  //====================================================//
  //==> Lists the videos for administration purposes <==//
  //====================================================//
  public function getAdminList(){
    $admindom="<ul class='content'>";$playerdom="";

    //Get the videos From DB
    $catlist = MyCat::getrecords();
    if(!empty($catlist)){foreach($catlist as $record){
    
     
    $admindom.='
    <li class="wrappev" id="MyCat_'.$record[id].'">
      <span>
	  <a class="fancy" href="#'.$record[id].'" title="'.$record[cname].'">
        '.$record[cname].'      </a>
        
      </span>
     &nbsp; &nbsp;  <a class="editvideolink" href="#">Edit</a> |
      <a class="deletevideolink" href="#" >Delete</a>
    </li>';
	 
    }}
    $admindom.="</ul>";
	  $dom='<div id="thumbnailsadmincontainer"><div class="page_navigation"></div>'.$admindom.'</div>
  ';
    return $dom;
    //return $admindom;
  }


  //====================================================//
  //====> Generates the markup for the public page <====//
  //====================================================//  
  public function getPublicSide(){
  	echo MyCat::getThumbnailsList();
  }


  //====================================================//
  //=====> Generates The markup for the Admin Page <====//
  //====================================================//  
  public function getAdminSide(){	
    //Table Creation (Uncomment to create the SQL Table)
    //MyVideo::createVideoTable();

    //Little API to Manage the posted data
    if(!empty($_POST)){
      MyCat::POSTManager();
    } 
    if($_POST['ajaxrequest']!=1){ //If not an ajax request
      //Get the Admin Form and the video List
      echo'
      <div id="adminwrap">
        <div id="addrecordwrap">
		 <h3 style="float:left">Add/Manage Categories</h3>
          <a href="#" class="submit" style="float:right">Add a new Category</a>
		  <div style="clear:both"></div>
        </div>
        <div id="recordform">';
          //Admin Form
          echo MyCat::getCatForm(0,"/admin/mangecat.php","post");
        echo'
        </div>
        <div id="recordlist">
        ';
          //Video List
          echo MyCat::getAdminList();	
        echo'</div>
      </div>';
     }
  }


  //=====================================================================//
  //==> Order an insert / update or delete based on the posted values <==//
  //=====================================================================//  
  public function POSTManager(){
    //What Are We Going to do?
    $action = htmlentities($_POST['todo'],ENT_QUOTES);
    switch($action){
      //Add or Edit a Video
      case "savecat": MyCat::save(); 
        echo'<div class="feedback">Category Saved Successfully</div>'; 
      break;
      
      //Remove a video
      case'delcat':
        $recordid = htmlentities($_POST['recordid'],ENT_QUOTES);
        if(!empty($recordid)){
          $record = new MyCat($recordid);
          $record->delete();
        }
      break;	
      
      //Load A video and return JSON
      case 'loadcat':
        $recordid = htmlentities($_POST['recordid'],ENT_QUOTES);
        if(!empty($recordid)){
          $record = MyCat::load($recordid);
          if(!empty($record)){
            echo'
            {
            "cat_id" : "'.$recordid.'",
            "cat_name" : "'.$record->cname.'"
            
            }';
          }
        }
      break;				
      default: break;
    }  
  }
  
//=============================================================================================================================//

}

?>