<?php

define("table_name","videos");

class MyVideo {

  //=======================================//
  //==========> Class Variables <==========//
  //=======================================//
  private $id;		//Id of the Video
  private $url;		//YouTube Url
  private $title;	//Video Title


//=======================================================================================//
//================================= Core Methods ========================================//
//=======================================================================================//
  

  //=======================================//
  //============> Constructor <============//
  //=======================================//
  public function __construct($id=0,$url="",$title="")
  {
    $this->id=$id;
    $this->url = $url;
    $this->title = $title;
  }
  
  


  
  //=======================================//
  //======> Load a Video Via its ID <======//
  //=======================================//
  public function load($id){
    //Select the Video Information from DB
    $sql="SELECT * FROM ".table_name." WHERE video_id = $id LIMIT 1";
    $result=array(); $video = new MyVideo();
    $req = mysql_query($sql) or die("Erreur SQL !<br>".$sql."<br>".mysql_error());
    
    //Assign those Infomation to a MyVideo Object
    while($data= mysql_fetch_assoc($req)) {
      $MyVideo->id = $data[video_id];
      $MyVideo->url = $data[video_url];
      $MyVideo->title = $data[video_title];
	    $MyVideo->desc = $data[video_desc];
	    $MyVideo->cid = $data[cid];
	    $MyVideo->feat = $data[feat];
    }
    
    return $MyVideo;    
  }

  
    public function loadcat(){
    //Select the Video Information from DB
    $sql="SELECT * FROM cat";
 $result=array();
    $req = mysql_query($sql) or die("SQL Error!<br>".$sql."<br>".mysql_error());
    while($data= mysql_fetch_assoc($req)) {
      $result[]=$data;
    }
    return $result;  
  }

  //=======================================//
  //======> Get Video List From DB <=======//  
  //=======================================//
  public function getrecords()
  {
    //Select all videos from DB
    $sql="SELECT * FROM ".table_name."";
    $result=array();
    $req = mysql_query($sql) or die("SQL Error!<br>".$sql."<br>".mysql_error());
    while($data= mysql_fetch_assoc($req)) {
      $result[]=$data;
    }
    return $result;
  }  
  
     public function getvrecords()
  {
    //Select all videos from DB
    $sql="SELECT * FROM videos order by video_id desc limit 20";
    $result=array();
    $req = mysql_query($sql) or die("SQL Error!<br>".$sql."<br>".mysql_error());
    while($data= mysql_fetch_assoc($req)) {
      $result[]=$data;
    }
    return $result;
  } 
    
  //==========================================//
  //== Display the form to add/edit a video ==//
  //==========================================//
  public function getVideoForm($videoid=0,$action="", $method="post"){
    //Load A Video if $videoid (Used to edit an existing video)
    if( (!empty($videoid)) && (is_numeric($videoid)) ){ 
      $video = MyVideo::load($videoid); 
    } else { 
      $video = new MyVideo(); 
    }
    
		 
		  $cats = MyVideo::loadcat();
		  
	
    //The Form Markup (Video Url, + Video Title)
    $form='<form id="qform" action="'.$action.'" method="'.$method.'">
      <div class="regrow">
	  
        <label class="inside" for="video_url">YouTube url:</label>
        <input id="youtubeDataFetcherInput"  type="text" name="video_url" class="text required" style="width:400px" value="'.$video->url.'" />
		 <input type="button" value="Fetch Video Info" class="submit"  onClick="youtubeFetchData( );">
		 <br/>
		 OR<br/>
		    <label class="inside" for="video_url">Search Youtube:</label>
		 <input type="text" class="search_input"  /><input id="searchyou" type="button" class="submit" value="Search"/><br/> 
		 
		
		
      </div>
	  <div id="closed" style="border-radius:100px;position:absolute;color:white;background-color:black;border:2px solid #FFF;display:none;padding:10px;">X</div>
	  <div id="video" class="triangle-border top"	  style="position:absolute;overflow:scroll;height:300px;display:none;width:700px"> 
 
</div> 
      <div class="regrow1">
        <label class="inside" for="video_title">Video Title:</label>
        <input id="uvideotitle" type="text" name="video_title" class="text required" style="width:400px" value="'.$video->title.'" />
		 <label class="inside" for="video_url">Category:</label>
		 <select id="vidcat" name="video_cat" class="text required" style="width:120px;float:right">';
		foreach($cats as $cat){
		$form.=' <option value="'.$cat["id"].'">'.$cat["cname"].'</option> ';

		}
		$form.='</select><br>
		<label class="inside" for="video_url" >Is this Featured Video?:</label>
	<input name="feat"  id="showhide" type="checkbox" value="yes" /><br/><br/>
		 <label class="inside" for="video_url">Description:</label><br/>
		<textarea style="width:400px"  id="uvideodesc" name="video_desc" class="text required"  >'.$video->desc.'</textarea>
		  <div id="youtubeDataFetcherOutput">Video information will appear here.</div>
     
        <input type="hidden" name="video_id" value="'.$video->id.'" />
        <input type="hidden" name="todo" value="savevideo" />
        <input type="submit" class="submit" value="Submit" /> 
      
      </div>
	  <div style="float:left">  <input id="cancelctcform" type="button" class="submit" value="Cancel" /> </div>
	  <div style="clear:both"></div>
    </form>
	
	';
    return $form;
  }  
  
  
  //========================================//
  //== Insert / Update a Row in the Table ==//
  //========================================//
  public function save(){
    //Get Values From Post
    $id = htmlentities($_POST["video_id"],ENT_QUOTES);
    $url = htmlentities($_POST["video_url"],ENT_QUOTES);
    $title = htmlentities($_POST["video_title"],ENT_QUOTES);
    $cid = htmlentities($_POST["video_cat"],ENT_QUOTES);
    $feat = htmlentities($_POST["feat"],ENT_QUOTES);
	if($feat=='yes'){
	$feat=1;}
	else{
	$feat=0;
	}
	
	$desc = $_POST["video_desc"];
    
    if(!empty($url)){
      if (!$id) {	//Creation
	  $desc=str_replace("\"","'",$desc);
        $sql = "INSERT INTO ".table_name." (`video_url`,`video_title`,`cid`,`video_desc`,`feat`) VALUES (\"$url\",\"$title\",\"$cid\",\"$desc\",\"$feat\")";
        if(mysql_query($sql)) { return mysql_insert_id(); } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
      }
      else {		//Update  
        $modifs="";
		$desc=str_replace("\"","'",$desc);
        if(!empty($url)){ $modifs.=" `video_url` = \"$url\","; }
        if(!empty($cid)){ $modifs.=" `cid` = \"$cid\","; }
        if(!empty($title)){ $modifs.=" `video_title` = \"$title\","; }
		if(!empty($desc)){ $modifs.=" `video_desc` = \"$desc\","; }
		if(!empty($feat)){ 		$modifs.=" `feat` = $feat ,"; }
        $sql = "UPDATE ".table_name." SET ".substr($modifs,0,-1)." WHERE video_id = $id";        if(mysql_query($sql)) { return $id; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
      } 
    }
  }
  
  //==========================================//
  //============ Delete a Video ==============//
  //==========================================//
  public function delete(){
	$sql = "DELETE FROM ".table_name." WHERE video_id = ".(int)$this->id;
	if(mysql_query($sql)) { return true; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }  
  }


//=============================================================================================================================//  
//========================================= Examples Used in the Demonstration ================================================//
//=============================================================================================================================//


  //=======================================//
  //========== Create the Table ===========//
  //=======================================//
  public function createVideoTable(){
    $sql='CREATE TABLE IF NOT EXISTS `'.table_name.'` (
    `video_id` int(11) NOT NULL auto_increment,
    `video_url` varchar(255) default NULL,
    `video_title` varchar(255) default NULL,
    PRIMARY KEY  (`video_id`)
    )';
    if(mysql_query($sql)) { return true; } else { die("SQL Error!<br>".$sql."<br>".mysql_error()); return false; }
  }
  
  //==============================================//
  //==> Display the video Thumbnails on a page <==//
  //==============================================//
  public function getThumbnailsList(){
    
    $thumbdom=""; $playerdom="";
    
    //Get The videos from DB
    $videolist = MyVideo::getvrecords();
    
    //Loop Through Them
    if(!empty($videolist)){foreach($videolist as $video){
      
      //Get YouTube Id
      $youtubeid = str_replace("watch?v=","",end(explode("/",$video[video_url])));
      $youtubeid = reset(explode("&",$youtubeid));
      
      //Youtube video File + Youtube video Thumbnail
      $thumb = "http://img.youtube.com/vi/$youtubeid/1.jpg";
      $file = "http://www.youtube.com/v/$youtubeid";
      
      //Build Up your list of video
    /*  $thumbdom.='<li>
      <a class="fancy" href="#video'.$video[video_id].'" title="'.$video[video_title].'">
        <img src="'.$thumb.'" alt="'.$video[video_title].'" />
      </a>
      </li>';
      
      //Also adds the corresponding player for the video
      $playerdom.='<div class="video_player_wrap" id="video'.$video[video_id].'">
        <embed style="width:400px;height:350px" src="'.$file.'&autoplay=1&hl=en&fs=1
        &rel=0&color1=0x3a3a3a&color2=0x999999" 
        type="application/x-shockwave-flash" allowscriptaccess="always" 
        allowfullscreen="true" width="320" height="265"></embed>
      </div>'."\n";
	  */
	  $vtit=html_entity_decode(substr($video[video_title],0,50))."...";
	  $thumbdom.='<div class="bloc_video">	
	<img src="'.$thumb.'" alt="'.$vtit.'" height="80" width="107">
	<div class="t_vid">'.$vtit.'</div>
	<a class="see_vid" href="'.$video['video_id'].'_'.str_replace(" ","-",substr(html_entity_decode(strtolower($video['video_title'])),0,20)).'.html" title="'.$video[video_title].'">     </a>                   
	</div>';
    }}
   // $thumbdom.="</ul>";
    //$dom='<div id="thumbnailscontainer">'.$thumbdom.'</div>';
    //<div id="playercontainer">'.$playerdom.'</div>';
	
	
    return $thumbdom;
  }
  
  
  //====================================================//
  //==> Lists the videos for administration purposes <==//
  //====================================================//
  public function getAdminList(){
    $admindom="<ul class='content'>";$playerdom="";

    //Get the videos From DB
    $videolist = MyVideo::getrecords();
    if(!empty($videolist)){foreach($videolist as $record){
    //Build the Admin List of videos
	 $youtubeid = str_replace("watch?v=","",end(explode("/",$record[video_url])));
      $youtubeid = reset(explode("&",$youtubeid));
      
      //Youtube video File + Youtube video Thumbnail
      $thumb = "http://img.youtube.com/vi/$youtubeid/1.jpg";
      $file = "http://www.youtube.com/v/$youtubeid";
    $admindom.='
    <li class="wrappev" id="MyVideo_'.$record[video_id].'">
      <span>
	  <a class="fancy" href="#video'.$record[video_id].'" title="'.$record[video_title].'">
        <img src="'.$thumb.'" alt="'.$record[video_title].'" />
      </a>
        
      </span>
     &nbsp; &nbsp;  <a class="editvideolink" href="#">Edit</a> |
      <a class="deletevideolink" href="#" >Delete</a>
    </li>';
	 $playerdom.='<div class="video_player_wrap" id="video'.$record[video_id].'">
        <embed style="width:400px;height:350px" src="'.$file.'&autoplay=1&hl=en&fs=1
        &rel=0&color1=0x3a3a3a&color2=0x999999" 
        type="application/x-shockwave-flash" allowscriptaccess="always" 
        allowfullscreen="true" width="320" height="265"></embed>
      </div>'."\n";
    }}
    $admindom.="</ul>";
	  $dom='<div id="thumbnailsadmincontainer"><div class="page_navigation"></div>'.$admindom.'</div>
    <div id="playercontainer">'.$playerdom.'</div>';
    return $dom;
    //return $admindom;
  }


  //====================================================//
  //====> Generates the markup for the public page <====//
  //====================================================//  
  public function getPublicSide(){
  	echo MyVideo::getThumbnailsList();
  }


  //====================================================//
  //=====> Generates The markup for the Admin Page <====//
  //====================================================//  
  public function getAdminSide(){	
    //Table Creation (Uncomment to create the SQL Table)
    //MyVideo::createVideoTable();

    //Little API to Manage the posted data
    if(!empty($_POST)){
      MyVideo::POSTManager();
    } 
    if($_POST['ajaxrequest']!=1){ //If not an ajax request
      //Get the Admin Form and the video List
      echo'
      <div id="adminwrap">
        <div id="addrecordwrap">
		 <h3 style="float:left">Add/Manage Videos</h3>
          <a href="#" class="submit" style="float:right">Add a new Video</a>
		  <div style="clear:both"></div>
        </div>
        <div id="recordform">';
          //Admin Form
          echo MyVideo::getVideoForm(0,"/admin/","post");
        echo'
        </div>
        <div id="recordlist">
        ';
          //Video List
          echo MyVideo::getAdminList();	
        echo'</div>
      </div>';
     }
  }


  //=====================================================================//
  //==> Order an insert / update or delete based on the posted values <==//
  //=====================================================================//  
  public function POSTManager(){
    //What Are We Going to do?
    $action = htmlentities($_POST['todo'],ENT_QUOTES);
    switch($action){
      //Add or Edit a Video
      case "savevideo": MyVideo::save(); 
        echo'<div class="feedback">Video Saved Successfully</div>'; 
      break;
      
      //Remove a video
      case'delvideo':
        $recordid = htmlentities($_POST['recordid'],ENT_QUOTES);
        if(!empty($recordid)){
          $record = new MyVideo($recordid);
          $record->delete();
        }
      break;	
      
      //Load A video and return JSON
      case 'loadvideo':
        $recordid = htmlentities($_POST['recordid'],ENT_QUOTES);
        if(!empty($recordid)){
          $record = MyVideo::load($recordid);
          if(!empty($record)){
            echo'
            {
            "video_id" : "'.$recordid.'",
            "video_title" : "'.$record->title.'",
            "video_file" : "'.$record->url.'",
            "cat" : "'.$record->cid.'",
			 "video_desc" : "'.$record->desc.'",
			 "feat" : "'.$record->feat.'"
            }';
          }
        }
      break;				
      default: break;
    }  
  }
  
//=============================================================================================================================//

}

?>